[![GitHub Action](https://github.com/thibaultduponchelle/tryperl/actions/workflows/lint.yml/badge.svg)](https://github.com/thibaultduponchelle/tryperl/actions/workflows/lint.yml)

# Try Perl
![TryPerlLogo](logo.png)

## Intro
*Learn the basics of the Perl language in your browser* !

This is the code that is running the [Try Perl](http://tryperl.pl) website.

Now using **Mojolicious::Lite** and **Websockets** !

## Preview 
![](tryperl.png)

## Lessons
[Try Perl](http://tryperl.pl) is a complete tutorial... within your browser !

Look at the full list of lessons :
* [Try perl](http://tryperl.pl/index.html?lesson=0)
* [Reverse the onion](http://tryperl.pl/index.html?lesson=1)
* [Uppercase](http://tryperl.pl/index.html?lesson=2)
* [Length](http://tryperl.pl/index.html?lesson=3)
* [Basic math](http://tryperl.pl/index.html?lesson=4)
* [Magic string](http://tryperl.pl/index.html?lesson=5)
* [One variable](http://tryperl.pl/index.html?lesson=6)
* [Weakly typed variable](http://tryperl.pl/index.html?lesson=7)
* [Itoa](http://tryperl.pl/index.html?lesson=8)
* [Small strings](http://tryperl.pl/index.html?lesson=9)
* [And atoi !](http://tryperl.pl/index.html?lesson=10)
* [Chomp chomp chomp](http://tryperl.pl/index.html?lesson=11)
* [Ready, Steady, Chomp !](http://tryperl.pl/index.html?lesson=12)
* [Chomp over there](http://tryperl.pl/index.html?lesson=13)
* [Arrays](http://tryperl.pl/index.html?lesson=14)
* [Still arrays](http://tryperl.pl/index.html?lesson=15)
* [Onion removal](http://tryperl.pl/index.html?lesson=16)
* [Bubble pop](http://tryperl.pl/index.html?lesson=17)
* [Push a button](http://tryperl.pl/index.html?lesson=18)
* [Push push](http://tryperl.pl/index.html?lesson=19)
* [For foreach](http://tryperl.pl/index.html?lesson=20)
* [Splice and range](http://tryperl.pl/index.html?lesson=21)
* [Getting items](http://tryperl.pl/index.html?lesson=22)
* [Playing with items](http://tryperl.pl/index.html?lesson=23)
* [No more mess](http://tryperl.pl/index.html?lesson=24)
* [Sorting](http://tryperl.pl/index.html?lesson=25)
* [Endless](http://tryperl.pl/index.html?lesson=26)
* [String concatenation](http://tryperl.pl/index.html?lesson=27)
* [Banana split](http://tryperl.pl/index.html?lesson=28)
* [Split result](http://tryperl.pl/index.html?lesson=29)
* [Conditions](http://tryperl.pl/index.html?lesson=30)
* [Do if unless](http://tryperl.pl/index.html?lesson=31)
* [True lies](http://tryperl.pl/index.html?lesson=32)
* [It's logic !](http://tryperl.pl/index.html?lesson=33)
* [Ternary operators](http://tryperl.pl/index.html?lesson=34)
* [Hash](http://tryperl.pl/index.html?lesson=35)
* [Still hashes](http://tryperl.pl/index.html?lesson=36)
* [Hashes of onion](http://tryperl.pl/index.html?lesson=37)
* [Variable types](http://tryperl.pl/index.html?lesson=38)
* [Refs](http://tryperl.pl/index.html?lesson=39)
* [Derefs](http://tryperl.pl/index.html?lesson=40)
* [Subs](http://tryperl.pl/index.html?lesson=41)
* [Grep](http://tryperl.pl/index.html?lesson=42)
* [World map](http://tryperl.pl/index.html?lesson=43)
* [Perl culture](http://tryperl.pl/index.html?lesson=44)
* [Onion award](http://tryperl.pl/index.html?lesson=45)


Enjoy ! 

## Contributors
Thank you a lot to the following people :

- [lcfg](https://github.com/lcfg)
- [b4shful](https://github.com/b4shful)

## See also
Used to build this website or source of inspiration :

- [JQuery console](https://github.com/chrisdone/jquery-console) - The javascript code used for the interactive console

- [TryRuby](https://try.ruby-lang.org) - This is not the original version but I wanted to put a link


Since I created [Try Perl](http://tryperl.pl), a new online Perl runner site appeared [Perl Banjo](https://perlbanjo.com) really deserves a visit.


Some other links in the field of "Perl in a browser"  : 

- [WebPerl](https://webperl.zero-g.net/)

- [Perlbot](https://perl.bot) 

